MusicModule = MusicModule or class(ItemModuleBase)
MusicModule.type_id = "Music"

function MusicModule:init(core_mod, config)
    if not self.super.init(self, core_mod, config) then
        return false
    end
    return true
end

function MusicModule:RegisterHook()
	self._config.id = self._config.id or "Err"
	if not self._config.source then
		self:log("[ERROR] No source was specified for the music %s", self._config.id)
		return
	end	
	if BeardLib._music[self._config.id] then
		self:log("[ERROR] Music with the id '%s' already exists!", self._config.id)
		return
	end
	if self._config.directory then
		self._config.source = self._config.directory .. "/" .. self._config.source
		for k,v in pairs(self._config) do
			if type(k) == "number" and type(v) == "table" and v._meta == "event" then
				if v.start_source then
					v.start_source = self._config.directory  .. "/" .. v.start_source
				end
				if v.source then
					v.source = self._config.directory  .. "/" .. v.source
				else
					self:log("[ERROR] Music with the id '%s' has an event that has no source!", self._config.id)
					return
				end
			end
		end
	end
	BeardLib._music[self._config.id] = self._config
end

BeardLib:RegisterModule(MusicModule.type_id, MusicModule)
